#include "backend/drm/util.h"

#define PNP_ID(a, b, c) ((a & 0x1f) << 10) | ((b & 0x1f) << 5) | (c & 0x1f)
const char *get_pnp_manufacturer(const char code[static 3]) {
	switch (PNP_ID(code[0], code[1], code[2])) {
	case PNP_ID('A', 'A', 'A'): return "Avolites Ltd";
	case PNP_ID('A', 'A', 'E'): return "Anatek Electronics Inc.";
	case PNP_ID('A', 'A', 'M'): return "Aava Mobile Oy";
	case PNP_ID('A', 'A', 'N'): return "AAEON Technology Inc.";
	case PNP_ID('A', 'A', 'T'): return "Ann Arbor Technologies";
	case PNP_ID('A', 'B', 'A'): return "ABBAHOME INC.";
	case PNP_ID('A', 'B', 'C'): return "AboCom System Inc.";
	case PNP_ID('A', 'B', 'D'): return "Allen Bradley Company";
	case PNP_ID('A', 'B', 'E'): return "Alcatel Bell";
	case PNP_ID('A', 'B', 'O'): return "D-Link Systems Inc";
	case PNP_ID('A', 'B', 'S'): return "Abaco Systems, Inc.";
	case PNP_ID('A', 'B', 'T'): return "Anchor Bay Technologies, Inc.";
	case PNP_ID('A', 'B', 'V'): return "Advanced Research Technology";
	case PNP_ID('A', 'C', 'A'): return "Ariel Corporation";
	case PNP_ID('A', 'C', 'B'): return "Aculab Ltd";
	case PNP_ID('A', 'C', 'C'): return "Accton Technology Corporation";
	case PNP_ID('A', 'C', 'D'): return "AWETA BV";
	case PNP_ID('A', 'C', 'E'): return "Actek Engineering Pty Ltd";
	case PNP_ID('A', 'C', 'G'): return "A&R Cambridge Ltd.";
	case PNP_ID('A', 'C', 'H'): return "Archtek Telecom Corporation";
	case PNP_ID('A', 'C', 'I'): return "Ancor Communications Inc";
	case PNP_ID('A', 'C', 'K'): return "Acksys";
	case PNP_ID('A', 'C', 'L'): return "Apricot Computers";
	case PNP_ID('A', 'C', 'M'): return "Acroloop Motion Control Systems Inc";
	case PNP_ID('A', 'C', 'O'): return "Allion Computer Inc.";
	case PNP_ID('A', 'C', 'P'): return "Aspen Tech Inc";
	case PNP_ID('A', 'C', 'R'): return "Acer Technologies";
	case PNP_ID('A', 'C', 'S'): return "Altos Computer Systems";
	case PNP_ID('A', 'C', 'T'): return "Applied Creative Technology";
	case PNP_ID('A', 'C', 'U'): return "Acculogic";
	case PNP_ID('A', 'C', 'V'): return "ActivCard S.A";
	case PNP_ID('A', 'D', 'A'): return "Addi-Data GmbH";
	case PNP_ID('A', 'D', 'B'): return "Aldebbaron";
	case PNP_ID('A', 'D', 'C'): return "Acnhor Datacomm";
	case PNP_ID('A', 'D', 'D'): return "Advanced Peripheral Devices Inc";
	case PNP_ID('A', 'D', 'E'): return "Arithmos, Inc.";
	case PNP_ID('A', 'D', 'H'): return "Aerodata Holdings Ltd";
	case PNP_ID('A', 'D', 'I'): return "ADI Systems Inc";
	case PNP_ID('A', 'D', 'K'): return "Adtek System Science Company Ltd";
	case PNP_ID('A', 'D', 'L'): return "ASTRA Security Products Ltd";
	case PNP_ID('A', 'D', 'M'): return "Ad Lib MultiMedia Inc";
	case PNP_ID('A', 'D', 'N'): return "Analog & Digital Devices Tel. Inc";
	case PNP_ID('A', 'D', 'P'): return "Adaptec Inc";
	case PNP_ID('A', 'D', 'R'): return "Nasa Ames Research Center";
	case PNP_ID('A', 'D', 'S'): return "Analog Devices Inc";
	case PNP_ID('A', 'D', 'T'): return "Adtek";
	case PNP_ID('A', 'D', 'V'): return "Advanced Micro Devices Inc";
	case PNP_ID('A', 'D', 'X'): return "Adax Inc";
	case PNP_ID('A', 'D', 'Z'): return "ADDER TECHNOLOGY LTD";
	case PNP_ID('A', 'E', 'C'): return "Antex Electronics Corporation";
	case PNP_ID('A', 'E', 'D'): return "Advanced Electronic Designs, Inc.";
	case PNP_ID('A', 'E', 'I'): return "Actiontec Electric Inc";
	case PNP_ID('A', 'E', 'J'): return "Alpha Electronics Company";
	case PNP_ID('A', 'E', 'M'): return "ASEM S.p.A.";
	case PNP_ID('A', 'E', 'N'): return "Avencall";
	case PNP_ID('A', 'E', 'P'): return "Aetas Peripheral International";
	case PNP_ID('A', 'E', 'T'): return "Aethra Telecomunicazioni S.r.l.";
	case PNP_ID('A', 'F', 'A'): return "Alfa Inc";
	case PNP_ID('A', 'G', 'C'): return "Beijing Aerospace Golden Card Electronic Engineering Co.,Ltd.";
	case PNP_ID('A', 'G', 'I'): return "Artish Graphics Inc";
	case PNP_ID('A', 'G', 'L'): return "Argolis";
	case PNP_ID('A', 'G', 'M'): return "Advan Int'l Corporation";
	case PNP_ID('A', 'G', 'O'): return "AlgolTek, Inc.";
	case PNP_ID('A', 'G', 'T'): return "Agilent Technologies";
	case PNP_ID('A', 'H', 'C'): return "Advantech Co., Ltd.";
	case PNP_ID('A', 'H', 'Q'): return "Astro HQ LLC";
	case PNP_ID('A', 'H', 'S'): return "Beijing AnHeng SecoTech Information Technology Co., Ltd.";
	case PNP_ID('A', 'I', 'C'): return "Arnos Insturments & Computer Systems";
	case PNP_ID('A', 'I', 'E'): return "Altmann Industrieelektronik";
	case PNP_ID('A', 'I', 'I'): return "Amptron International Inc.";
	case PNP_ID('A', 'I', 'K'): return "Dongguan Alllike Electronics Co., Ltd.";
	case PNP_ID('A', 'I', 'L'): return "Altos India Ltd";
	case PNP_ID('A', 'I', 'M'): return "AIMS Lab Inc";
	case PNP_ID('A', 'I', 'R'): return "Advanced Integ. Research Inc";
	case PNP_ID('A', 'I', 'S'): return "Alien Internet Services";
	case PNP_ID('A', 'I', 'W'): return "Aiwa Company Ltd";
	case PNP_ID('A', 'I', 'X'): return "ALTINEX, INC.";
	case PNP_ID('A', 'J', 'A'): return "AJA Video Systems, Inc.";
	case PNP_ID('A', 'K', 'B'): return "Akebia Ltd";
	case PNP_ID('A', 'K', 'E'): return "AKAMI Electric Co.,Ltd";
	case PNP_ID('A', 'K', 'I'): return "AKIA Corporation";
	case PNP_ID('A', 'K', 'L'): return "AMiT Ltd";
	case PNP_ID('A', 'K', 'M'): return "Asahi Kasei Microsystems Company Ltd";
	case PNP_ID('A', 'K', 'P'): return "Atom Komplex Prylad";
	case PNP_ID('A', 'K', 'R'): return "Anker Innovations Limited";
	case PNP_ID('A', 'K', 'Y'): return "Askey Computer Corporation";
	case PNP_ID('A', 'L', 'A'): return "Alacron Inc";
	case PNP_ID('A', 'L', 'C'): return "Altec Corporation";
	case PNP_ID('A', 'L', 'D'): return "In4S Inc";
	case PNP_ID('A', 'L', 'E'): return "Alenco BV";
	case PNP_ID('A', 'L', 'G'): return "Realtek Semiconductor Corp.";
	case PNP_ID('A', 'L', 'H'): return "AL Systems";
	case PNP_ID('A', 'L', 'I'): return "Acer Labs";
	case PNP_ID('A', 'L', 'J'): return "Altec Lansing";
	case PNP_ID('A', 'L', 'K'): return "Acrolink Inc";
	case PNP_ID('A', 'L', 'L'): return "Alliance Semiconductor Corporation";
	case PNP_ID('A', 'L', 'M'): return "Acutec Ltd.";
	case PNP_ID('A', 'L', 'N'): return "Alana Technologies";
	case PNP_ID('A', 'L', 'O'): return "Algolith Inc.";
	case PNP_ID('A', 'L', 'P'): return "ALPS ALPINE CO., LTD.";
	case PNP_ID('A', 'L', 'R'): return "Advanced Logic";
	case PNP_ID('A', 'L', 'S'): return "Avance Logic Inc";
	case PNP_ID('A', 'L', 'T'): return "Altra";
	case PNP_ID('A', 'L', 'V'): return "AlphaView LCD";
	case PNP_ID('A', 'L', 'X'): return "ALEXON Co.,Ltd.";
	case PNP_ID('A', 'M', 'A'): return "Asia Microelectronic Development Inc";
	case PNP_ID('A', 'M', 'B'): return "Ambient Technologies, Inc.";
	case PNP_ID('A', 'M', 'C'): return "Attachmate Corporation";
	case PNP_ID('A', 'M', 'D'): return "Amdek Corporation";
	case PNP_ID('A', 'M', 'I'): return "American Megatrends Inc";
	case PNP_ID('A', 'M', 'L'): return "Anderson Multimedia Communications (HK) Limited";
	case PNP_ID('A', 'M', 'N'): return "Amimon LTD.";
	case PNP_ID('A', 'M', 'O'): return "Amino Technologies PLC and Amino Communications Limited";
	case PNP_ID('A', 'M', 'P'): return "AMP Inc";
	case PNP_ID('A', 'M', 'R'): return "AmTRAN Technology Co., Ltd.";
	}
	return NULL;
}
#undef PNP_ID
